﻿Type=Activity
Version=3.2
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These varibles can be accessed from all modules.
	
	Dim MyTimer As Timer

End Sub

Sub Globals

	Dim DisplayCounter As Label
	
	Dim red As ImageView
	Dim Green As ImageView
	Dim Yellow As ImageView
	
	Dim CountNum As EditText
	Dim PauseNum As EditText
	Dim Repeat As Label
	
	Dim Panel1 As Panel	
	
	Dim Plus As ImageView
	Dim PanelPlus As Panel
	Dim Minus As ImageView
	Dim PanelMinus As Panel

	Dim MyBeeper As Beeper  'Need audio library

	Dim i As Long
	Dim t As Long
	Dim t1 As Long
	
End Sub


Sub TimerStart

	i = 0
	t1=DateTime.Now    
	MyTimer.Enabled = True 
	
End Sub

Sub MyTimer_Tick   
	
	If Main.Abort Then 
		MyTimer.Enabled = False
		MyBeeper.beep
	Else

		i = i + 1
		
		If Main.countUpDown = 1 Then 
			DisplayCounter.Text = 0 + i
		Else
			DisplayCounter.Text = t - i
		End If
					
		If i >= t  Then 
			MyTimer.Enabled = False
	   	End If
		
	End If
	
End Sub




Sub Activity_KeyPress (KeyCode As Int) As Boolean 'return true if you want to consume the event

	If KeyCode = KeyCodes.KEYCODE_BACK Then
		'*** Put code here To Do what you want. If you want To control what 'Back' is doing you can handle it
		'*** here (such As stopping the Beep). Then Return True If you Do Not want the system To process it
		'*** (If you don't really want to let the system go back), otherwise return False and the system will
		'*** process it normally.
		Main.Abort = True
		Return True
	Else
		Return False
	End If

End Sub 




Sub Activity_Resume
		
	MyTimer.Initialize("MyTimer", 1000) 

End Sub
Sub Activity_Pause (UserClosed As Boolean)
	
	MyBeeper.Release
	SaveTheStuff	
	
	If UserClosed Then
		Activity.Finish
	End If
	
End Sub



Sub Activity_Create(FirstTime As Boolean)
	
	'Load main layout file.
    Activity.LoadLayout("Main") 
	
	MyBeeper.Initialize(300, Main.Frequency1) '200 milliseconds, 500 hz

	If FirstTime Then
		LoadTheStuff
	End If
	
	Start
	
End Sub

Sub Start
	
	Setup
	GreenStart

End Sub

Sub GreenStart	
	
	Do While (Main.ContinuousRepeat)
		GreenGoOnce
	Loop
	
	Repeat.Enabled = True
	
	Panel1.Enabled = True
	Panel1.Visible = True
	
	DisplayCounter.Text = "Start"
	
	Green.Enabled = True
	Green.Visible = True

	red.Enabled = False
	red.Visible = False

	Yellow.Enabled = False
	Yellow.Visible = False
	
End Sub


Sub Green_click
	
		Repeat.Enabled = False 'Visible but not active
		
		Panel1.Visible = False
		Panel1.Enabled = False
				
		Green.Enabled = False
		Green.Visible = False
		
		red.Enabled = True
		Yellow.Enabled = True

		Main.Abort = False
		
		GreenGoOnce
		GreenStart
	
End Sub
Sub GreenGoOnce
 
	If Main.CountLengthInSeconds > 0 Then
		RedRun
		If Main.Abort Then 
		Else
			If Main.PauseLengthInSeconds > 0 Then
				YellowRun
				If Main.Abort Then 
				Else
					MyBeeper.Beep
				End If
			Else 
				MyBeeper.Beep
			End If
		End If
	End If

End Sub

Sub Red_click

	Main.Abort = True
	Main.ContinuousRepeat = False
	Repeat.Text = "Repeat OFF"

End Sub
Sub RedRun
		
	DisplayCounter.Text = "Start"
	
	red.Visible = True
	Yellow.Visible = False
	MyBeeper.Beep
		
	t = Main.CountLengthInSeconds
	TimerStart
		
End Sub
Sub Yellow_click

	Main.Abort = True
	Main.ContinuousRepeat = False
	Repeat.Text = "Repeat OFF"

End Sub
Sub YellowRun
	
	DisplayCounter.Text = "Pause"

	red.Visible = False
	Yellow.Visible = True
	MyBeeper.Beep

	t = Main.PauseLengthInSeconds
	TimerStart

End Sub



Sub Plus_click

	Main.countUpDown = 1
	
	Plus.Enabled = False
	Minus.Enabled = True
	
	PanelPlus.Visible = True
	PanelMinus.Visible = False
	
End Sub
Sub Minus_click

	Main.countUpDown = -1
	
	Plus.Enabled = True
	Minus.Enabled = False
	
	PanelPlus.Visible = False
	PanelMinus.Visible = True
	
End Sub
Sub Repeat_click

	If Main.ContinuousRepeat  = True Then
		Main.ContinuousRepeat = False
		Repeat.Text = "Repeat OFF"
	Else
		Main.ContinuousRepeat = True
		Repeat.Text = "Repeat ON"
	End If
	
End Sub	
Sub CountNum_FocusChanged (HasFocus As Boolean)

	Try
	   If HasFocus = False Then
	      ' lost focus	
	   End If
	Catch
		CountNum.text = Main.CountLengthInSeconds
	End Try
	
	Reload
	'SaveTheStuff
	
End Sub
Sub PauseNum_FocusChanged (HasFocus As Boolean)

	Try
	   If HasFocus = False Then
	      ' lost focus	
	   End If
	Catch
		PauseNum.text = Main.PauseLengthInSeconds 
	End Try
	
	Reload
	'SaveTheStuff
	
End Sub



Sub Setup

	DisplayCounter.TextColor = Colors.Black
	DisplayCounter.Enabled = False
	Repeat.Visible = True
	
End Sub
Sub Reload

	Main.CountLengthInSeconds = CountNum.text 
	Main.PauseLengthInSeconds = PauseNum.text
			
End Sub


Sub LoadTheStuff()

	Try
	
		Main.SaveList.Clear
		Main.SaveList = File.ReadList(File.DirInternalCache, "SportsCounter.txt")

		Dim j As Int

		j = 0
		CountNum.text = Main.SaveList.get(j) 
		j = j + 1   
		PauseNum.text = Main.SaveList.get(i) 		
		
	Catch
	
		'set defaults
		CountNum.text = 10
		PauseNum.text = 5
				
	End Try

	Minus_click
	Reload
	
End Sub
Sub SaveTheStuff()

	Main.SaveList.clear
		
	Main.SaveList.add (CountNum.Text) 
	Main.SaveList.add (PauseNum.Text) 
	Main.SaveList.add (Main.countUpDown)
	
	File.Delete(File.DirInternalCache, "SportsCounter.txt")
	File.WriteList (File.DirInternalCache, "SportsCounter.txt", Main.SaveList)
	
End Sub

